#ifndef ConnectionAttributesModel_h
#define ConnectionAttributesModel_h

// $Id: ConnectionAttributesModel.h,v 1.9 2014/02/18 15:15:56 hupereir Exp $

/******************************************************************************
*
* Copyright (C) 2002 Hugo PEREIRA <mailto: hugo.pereira@free.fr>
*
* This is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
*
* This software is distributed in the hope that it will be useful, but WITHOUT
* Any WARRANTY; without even the implied warranty of MERCHANTABILITY or
* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
* for more details.
*
* You should have received a copy of the GNU General Public License along with
* this program.  If not, see <http://www.gnu.org/licenses/>.
*
*******************************************************************************/

#include "ListModel.h"
#include "ConnectionAttributes.h"

#include <QIcon>

//! tunnel attributes model
class ConnectionAttributesModel: public ListModel<ConnectionAttributes>, public Counter
{

    Q_OBJECT

    public:

    //! column types
    enum ColumnTypes
    {
        Name,
        Host,
        User,
        Options,
        nColumns
    };

    //! constructor
    ConnectionAttributesModel( QObject* = 0 );

    //! destructor
    virtual ~ConnectionAttributesModel( void )
    {}

    //! data
    virtual QVariant data(const QModelIndex&, int) const;

    //! header data
    virtual QVariant headerData( int, Qt::Orientation, int = Qt::DisplayRole ) const;

    //! number of columns for a given index
    virtual int columnCount( const QModelIndex& = QModelIndex() ) const
    { return nColumns; }

    protected:

    //! sort
    virtual void _sort( int, Qt::SortOrder = Qt::AscendingOrder )
    {}

    private:

    //! list column names
    static const QString columnTitles_[nColumns];

    //! icon
    QIcon icon_;

};

#endif
